#ifndef _VIDMALLOC_H
#define _VIDMALLOC_H

#include <stdlib.h>

void VIDEO_Malloc_Initialize(
  void   *start,
  size_t  length,
  size_t  sbrk_amount
);

void *vidmalloc(
  size_t  size
);

void *vidcalloc(
  size_t nelem,
  size_t elsize
);

void *vidrealloc(
  void *ptr,
  size_t size
);

void vidfree(
  void *ptr
);

void vidmalloc_dump(void);

void vidmalloc_walk(size_t source, size_t printf_enabled);

#ifdef RTEMS_NEWLIB
void *_vidmalloc_r(
  struct _reent *ignored,
  size_t  size
);

void *_vidrealloc_r(
  struct _reent *ignored,
  void *ptr,
  size_t size
);

void _vidfree_r(
  struct _reent *ignored,
  void *ptr
);
#endif /* RTEMS_NEWLIB */

#endif /* !_VIDMALLOC_H */
